/********************************************************************
	               textbuffer.h	    
      file con le funzioni per la gestione del buffer di testo
	       Copyright - Andrea Mastroianni
	      Corso di Laurea in Informatica
	           Universita' di Pisa
		   Versione 07-11-2001
 ********************************************************************/
typedef struct {

  char *text; 

  int len ;

  int dim;

} Textbuffer;

int init_buffer(Textbuffer * buffer,
		int dimension) ; 
		
int insert_buffer(Textbuffer * buffer,
		  char *text,
		  int dimension) ;

int text_in_buffer(Textbuffer * buffer) ; 

int get_buffer(Textbuffer *buffer, 
	       char *text) ;

int get_buffer_length(Textbuffer *buffer) ; 
