/********************************************************************
		           xcde_dim.c 
	         Xml Compressed Documents Engine
 	        Codeword Dimension Information Program
		 Paolo Ferragina - Andrea Mastroianni
         Dipartimento di Informatica - Universita' di Pisa 
	               ferragin@di.unipi.it
                      mastroi@cli.di.unipi.it
********************************************************************/
#include"xcde_lib.h"
int main(int argc,
	 char *argv[])
{ XCDE_Console_Type XCDE_Console ; 

 int position=0 ; 

 int cw=0 ;

 int cw_len=0 ;

 int res=0 ;

 fprintf(stderr, "\t------------------------------------------------------------------") ; 
  
 fprintf(stderr, "\n\t\t        XCDE_DIM : Version 1.0 11-07-2002") ;
 
 fprintf(stderr, "\n\t\t         X.ml C.ompressed D.ocuments E.ngine") ; 
 
 fprintf(stderr, "\n\t\t        Paolo Ferragina - Andrea Mastroianni ") ;
 
 fprintf(stderr, "\n\t\t    Dipartimento di Informatica - Universita' di Pisa ") ;
 
 fprintf(stderr, "\n\t\t            XCDE File System Information ") ;  
 
 fprintf(stderr, "\n\t------------------------------------------------------------------\n\n") ; 

 if (argc != 3) { 

   fprintf(stderr, "\nParameters not correct\n") ;
   
   exit(-1) ; 
 }
 
 position=atoi(argv[2]) ;

 if (position < 0) { 

   fprintf(stderr, "\nPosition not correct\n") ;
   
   exit(-1) ;
 }

 /********************************************************************
			     Opening Console
  ********************************************************************/

 res=XCDE_Init_Console(argv[1],
		       &XCDE_Console) ; 

 if (res == -1) { 

   fprintf(stderr, "\nProblems with the XCDE_Init_Console function\n") ;
   
   exit(-1) ; 
 }
 
 /********************************************************************
		      Get the Codeword at the position
  ********************************************************************/

  res=XCDE_Get_Body_Forward_Codeword(position,
				     &cw,
				     &cw_len,
				     &XCDE_Console) ;

  if (res == -1) { 

    fprintf(stderr, "\nPosition not correct\n") ;
    
    XCDE_Finalize_Console(&XCDE_Console) ;
    
    exit(-1) ; 
  }
  
  fprintf(stdout, "%d", cw_len) ;

  /********************************************************************
		       Finalize the Console
  ********************************************************************/
  
  res=XCDE_Finalize_Console(&XCDE_Console) ; 

  if (res == -1) { 

    fprintf(stderr, "\nProblems in XCDE_Finalize_Console") ; 
    
    fflush(stderr) ; 
    
    exit(-1) ; 
  }
  
  return(0) ;
}



