/********************************************************************
		          _xcde_transf.c
	         Xml Compressed Documents Engine
      simple program used to transform a dictionary for search
		 Paolo Ferragina - Andrea Mastroianni
         Dipartimento di Informatica - Universita' di Pisa 
	               ferragin@di.unipi.it
                      mastroi@cli.di.unipi.it
********************************************************************/
#include<stdlib.h>
#include<stdio.h>

#define BUFFER_DIMENSION 1024

int main(int argc,
	 char *argv[]) 
{ int num_car_read=0 ;

 int state=0 ; 

 int buffer_start=0 ;

 char copy[BUFFER_DIMENSION] ;

 unsigned
   char done=0 ;

 char buff[BUFFER_DIMENSION] ;
 
 int point ;
 
 int k, j, i ;

 while(!feof(stdin))
 
   { num_car_read=fread(buff+buffer_start, 
			sizeof(char), 
			BUFFER_DIMENSION-buffer_start, 
			stdin) ;
   

   k=0 ;

   point=0 ;

   while(k<(num_car_read+buffer_start)) { 
     
     if (buff[k] == '&')   { 
       j=k;
       
       done=0 ;

       while(!done) { 
	 if ((j<num_car_read+buffer_start) 
	     && (buff[j] != ';') && (buff[j] != '\0'))

	   ++j ;

	 else done=1 ;

	 }

       if (j==num_car_read+buffer_start) {

	 for(i=k; i<num_car_read+buffer_start; ++i)

	   buff[i-k]=buff[i] ;

	 buffer_start=num_car_read+buffer_start-k ; 

	 if(point != 0) 
	   fwrite(copy, sizeof(char),point,stdout) ;
	 
	 point=0 ;

	 k=num_car_read+buffer_start; 
       }
	 
       else {
       
	 if (buff[j] == ';') 

	   { copy[point]= '&' ;

	   ++point ;
	   
	   k=(j+1) ;
	   }

	 else {

	   if (buff[j] == '\0')

	     { for(i=k ; i<j ; ++i, ++point, ++k)

	       copy[point]=buff[i] ;
	     
	     copy[point]='\n' ; 

	     ++k ; 

	     ++point ;

	     }
	 }
       
       }
     }

     else

       if (buff[k] == '\n') 

	{ copy[point]='\b' ; 

	++point ; 

	++k ;
	} 
	       
       else

	 if (buff[k] == '\0') 
	   
	   { copy[point]='\n' ;
	   
	   ++point ;
	   
	   ++k ;
	   }
     
	 else
	   
	   { copy[point]=buff[k] ;
	   
	   ++point ;
	   
	   ++k ;
	   }
   }
   
   if (point != 0) {
     
     fwrite(copy, 
	    sizeof(char), 
	    point, 
	    stdout) ;
     buffer_start=0; 
     point=0;
   }    

   }
 return ;
}
